]> git.pld-linux.org Git - packages/mysql.git/blame_incremental - mysql.init
- more unpackaged files
[packages/mysql.git] / mysql.init
... / ...
CommitLineData
1#!/bin/sh
2#
3# mysql A very fast and reliable SQL database engine
4#
5# chkconfig: 2345 84 25
6#
7# description: A very fast and reliable SQL database engine.
8#
9# $Id$
10
11# Source function library
12. /etc/rc.d/init.d/functions
13
14# Get network config
15. /etc/sysconfig/network
16
17# Get service config
18if [ -f /etc/sysconfig/mysql ]; then
19 . /etc/sysconfig/mysql
20else
21 nls "Error: %s not found" /etc/sysconfig/mysql
22 nls "%s can't be run." MySQL
23 exit 1
24fi
25
26if [ -n "$MYSQL_DB_CLUSTERS" ]; then
27 nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
28fi
29
30if [ -f /etc/mysql/clusters.conf ]; then
31 MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
32 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
33 nls "Warning: there are no configured clusters."
34 fi
35
36else
37 nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
38 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
39 nls "Warning: there are no configured clusters."
40 nls "Using default cluster /var/lib/mysql (compatibility mode)"
41 MYSQL_DB_CLUSTERS=/var/lib/mysql
42 fi
43fi
44
45
46# Check that networking is up
47if is_yes "${NETWORKING}"; then
48 if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
49 msg_network_down MySQL
50 exit 1
51 fi
52else
53 exit 0
54fi
55
56action="$1"
57
58# any db cluster as command line argument?
59if [ $# -gt 1 ]; then
60 shift
61 # perform action for specified clusters only
62 for a in "$@"; do
63 # try auto resolving from /etc/mysql/clusters.conf
64 if [[ "$a" != /* ]]; then
65 m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66 if [ -z "$m" ]; then
67 echo >&2 "Cluster name '$a' did not match anything!"
68 exit 1
69 fi
70 if [ $(echo "$m" | wc -l) -gt 1 ]; then
71 echo >&2 "Cluster name '$a' ambiguous:" $m
72 exit 1
73 fi
74 a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75 fi
76 DB_CLUSTERS="$DB_CLUSTERS $a"
77 done
78else
79 DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
80fi
81
82# global error log, if mysqld.conf hasn't migrated to log-error style
83MYSQL_ERRLOG=/var/log/mysql/mysqld.log
84MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
85
86#
87# Useful functions.
88#
89
90#
91# check for mysql status
92#
93# arguments:
94# $1 - db cluster
95# $2 - start|stop
96#
97# sets variables:
98# MYSQL_STATUS = starting | running | not running | died
99# MYSQL_PID = pid of mysqld process
100#
101mysqlstatus() {
102 clusterdir="$1"
103 mode="$2"
104
105 mysqlgetconfig "$clusterdir" status
106
107 MYSQL_STATUS="not running"
108 MYSQL_PID="unknown"
109 MYSQL_PIDFILE_PID=""
110 MYSQL_GREP_PID=""
111
112 if [ -f "$MYSQL_PIDFILE" ]; then
113 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114 fi
115
116 if [ -n "$MYSQL_PIDFILE_PID" ]; then
117 MYSQL_PID=$MYSQL_PIDFILE_PID
118 if [ ! -d "/proc/$MYSQL_PID" ]; then
119 MYSQL_STATUS="died"
120 return
121 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
122 MYSQL_STATUS="running"
123 return
124 fi
125 fi
126
127 if [ "$mode" = "start" ]; then
128 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
129 if [ -n "$MYSQL_GREP_PID" ]; then
130 MYSQL_PID=$MYSQL_GREP_PID
131 if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
132 if [ -f "$MYSQL_PIDFILE" ]; then
133 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134 fi
135 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136 MYSQL_PID=$MYSQL_PIDFILE_PID
137 MYSQL_STATUS="running"
138 return
139 else
140 MYSQL_STATUS="starting"
141 return
142 fi
143 fi
144 fi
145 fi
146
147 # else default, "not running"
148}
149
150# get mysql configuration in variables
151# MYSQL_CONFIG MYSQL_CLUSTER_DIR
152# MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
153#
154# arguments
155# $1 - db cluster
156# $2 - status | other
157
158mysqlgetconfig() {
159 local clusterdir="$1" config_file
160 local mode="$2"
161
162 # emulate old behaviour if only one cluster specified
163 if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
164 MYSQL_RA_COMPAT=yes
165 config_file=/etc/mysqld.conf
166 else
167 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
168 if [[ $config = /* ]]; then
169 config_file="$config"
170 elif [ -f "/etc/mysql/$config" ]; then
171 config_file="/etc/mysql/$config"
172 else
173 config_file="$clusterdir/mysqld.conf"
174 fi
175 fi
176
177 MYSQL_CLUSTER_DIR="$clusterdir"
178
179 if [ -z "$config_file" ]; then
180 nls "Error: Can't find config file for %s cluster" "$clusterdir"
181 if [ "$mode" = "status" ]; then
182 exit 3
183 else
184 exit 6
185 fi
186 else
187 MYSQL_CONFIG="$config_file"
188 fi
189
190 if [ ! -f "$config_file" ]; then
191 nls "Error: config file %s not found" "$config_file"
192 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
193 if [ "$mode" = "status" ]; then
194 exit 3
195 else
196 exit 6
197 fi
198 fi
199
200 # reset to initial state
201 MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
202
203 eval `awk -F= '
204 {
205 # undos
206 gsub(/\r$/, "");
207
208 # trim spaces
209 gsub(/^[\t ]+|[\t ]+$/, "", $1);
210 gsub(/^[\t ]+|[\t ]+$/, "", $2);
211 }
212
213 # skip comments and empty lines
214 /^[;#]|^ *$/ { next }
215
216 /^[ \t]*\[.*\][ \t]*$/ {
217 match($0, /\[.*\]/);
218 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
219 next;
220 }
221
222 section == "mysqld" {
223 if ($1 == "datadir") {
224 printf("MYSQL_DATA_DIR=%s;", $2);
225 } else if ($1 == "user") {
226 printf("MYSQL_USER=%s;", $2);
227 } else if ($1 == "pid-file") {
228 printf("MYSQL_PIDFILE=%s;", $2);
229 } else if ($1 == "socket") {
230 printf("MYSQL_SOCKET=%s;", $2);
231 } else if ($1 == "port") {
232 printf("MYSQL_PORT=%s;", $2);
233 } else if ($1 == "bind-address") {
234 printf("MYSQL_BIND_ADDRESS=%s;", $2);
235 } else if ($1 == "skip-networking") {
236 printf("MYSQL_SKIP_NETWORKING=1;");
237 } else if ($1 == "log-error") {
238 printf("MYSQL_LOG_ERROR=%s;", $2);
239 }
240 }
241 ' $config_file`
242
243 # error log not defined in config file. add one
244 if [ -z "$MYSQL_LOG_ERROR" ]; then
245 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
246 else
247 # unset, so mysqld would use value from config itself
248 unset MYSQL_LOG_ERROR
249 fi
250
251 if is_yes "$MYSQL_RA_COMPAT"; then
252 MYSQL_DATA_DIR_SUB=""
253 else
254 MYSQL_DATA_DIR_SUB="/mysqldb"
255 fi
256
257 if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
258 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
259 nls " MySQL can't be run."
260 exit 6
261 fi
262
263 if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
264 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
265 nls " MySQL can't be run."
266 exit 6
267 fi
268
269 if [ -z "$MYSQL_USER" ]; then
270 echo "$(nls 'MySQL user not configured properly')"'!' >&2
271 nls "Edit %s and configure it." "$config_file" >&2
272 exit 6
273 fi
274}
275
276# start mysql
277mysqlstart() {
278 local clusterdir="$1"
279 mysqlgetconfig "$clusterdir"
280 if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
281 nls "MySQL cluster %s not initialized." "$clusterdir"
282 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
283 exit 6
284 fi
285
286 msg_starting "MySQL $clusterdir"; busy
287 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
288 rm -f "$MYSQL_PIDFILE"
289
290
291 TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
292 /usr/bin/setsid /usr/sbin/mysqld \
293 --defaults-file=$MYSQL_CONFIG \
294 --datadir=$MYSQL_DATA_DIR \
295 --pid-file=$MYSQL_PIDFILE \
296 ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
297 $MYSQL_OPTIONS &
298 pid=$!
299
300 sleep 0.1
301 mysqlstatus "$clusterdir" start
302 # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
303 if [ "$MYSQL_STATUS" = "starting" ]; then
304 echo ""
305 show "Waiting for MySQL to start"
306 busy
307
308 # while the pid is running, mysql is starting up
309 # if the pidfile was created, it started up successfully
310 # if either case fails we break and report status
311 while true; do
312 [ -d /proc/$pid ] || break
313 [ -f "$MYSQL_PIDFILE" ] && break
314 sleep 0.2
315 done
316 fi
317
318 mysqlstatus "$clusterdir" start
319 if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
320 ok
321 elif [ "$MYSQL_STATUS" = "died" ]; then
322 RETVAL=1
323 died
324 else
325 RETVAL=1
326 fail
327 fi
328}
329
330# stop mysql
331mysqlstop() {
332 local clusterdir="$1"
333 mysqlstatus "$clusterdir" stop
334 msg_stopping "MySQL $clusterdir"
335 busy
336
337 # try graceful shutdown -- send shutdown command
338 # requires mysql_sysadmin user proper privs
339 /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
340 mysqlstatus "$clusterdir" stop
341
342 if [ "$MYSQL_PID" != "unknown" ]; then
343 kill -TERM "$MYSQL_PID" 2> /dev/null
344 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
345 [ -d "/proc/$MYSQL_PID" ] || break
346 sleep 0.1
347 done
348 fi
349
350 mysqlstatus "$clusterdir" stop
351 if [ "$MYSQL_STATUS" = "died" ]; then
352 died
353 elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
354 fail
355 else
356 ok
357 fi
358}
359
360#
361# check for running mysql instances; if any instance is running then
362# create subsys lock file
363#
364mysqlsubsys() {
365 # check for every defined db cluster in sysconfig file
366 for mysqldir in $DB_CLUSTERS; do
367 mysqlstatus "$mysqldir"
368 if [ "$MYSQL_STATUS" = "running" ]; then
369 touch /var/lock/subsys/mysql
370 return
371 fi
372 done
373 rm -f /var/lock/subsys/mysql
374}
375
376mysqlinit() {
377 local clusterdir="$1"
378
379 if [ -f /etc/mysqld.conf ]; then
380 nls "Running in \`no cluster compat' mode: can't initialize database."
381 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
382 exit 1
383 fi
384
385 if [ -f "$clusterdir/mysqld.conf" ]; then
386 mysqlgetconfig "$clusterdir"
387 else
388 MYSQL_USER="mysql"
389 MYSQL_CLUSTER_DIR="$clusterdir"
390 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
391 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
392 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
393
394 # this $MYSQL_CONFIG will be created later
395 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
396 fi
397
398 show "Initializing cluster %s" "$clusterdir"; started
399
400 # Check if not exist init database
401 if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
402 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
403 nls "before initializing database."
404 nls "For now skipping cluster %s." "$clusterdir"
405 return
406 fi
407
408 show "Installing MySQL system tables for $MYSQL_DATA_DIR"
409 busy
410 TMP=/tmp TMPDIR=/tmp
411
412 mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
413 # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
414 chown root:root "$MYSQL_CLUSTER_DIR"
415 chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
416 chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
417
418 if [ -f /usr/share/mysql/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
419 sed -e "
420 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
421 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
422 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
423 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
424 " /usr/share/mysql/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
425 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
426 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
427 fi
428
429 if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
430 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
431 ln -s "$sock" /var/lib/mysql/mysql.sock
432 fi
433
434 cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
435 CREATE DATABASE mysql;
436 use mysql;
437 $(cat /usr/share/mysql/mysql_system_tables.sql)
438 $(sed -e "/@current_hostname/d" /usr/share/mysql/mysql_system_tables_data.sql)
439EOF
440
441 ok=0
442 /usr/sbin/mysqld \
443 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
444 --bootstrap \
445 --skip-grant-tables \
446 --datadir=$MYSQL_DATA_DIR \
447 --user=$MYSQL_USER \
448 --slave-load-tmpdir=$MYSQL_DATA_DIR \
449 --tmpdir=$MYSQL_DATA_DIR \
450 --log-error=$MYSQL_ERRLOG \
451 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
452 [ -f $MYSQL_DATA_DIR/mysql/host.frm ] || ok=0
453
454 if [ "$ok" = 1 ]; then
455 rm -f $MYSQL_DATA_DIR/mysql-init.sql
456 ok
457 cat << END_OF_MSG
458
459PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
460This is done, after starting database, in the order shown,
461with:
462
463For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
464echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
465
466For 'mysql' user (ALL privileges, DB admin):
467echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
468
469NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
470mysqladmin section. See the manual for more instructions.
471(This user is used at logs rotation and server shutdown)
472
473END_OF_MSG
474 show "Filling help tables..."
475 ok=0
476 ( echo "use mysql;"; cat /usr/share/mysql/fill_help_tables.sql ) | \
477 /usr/sbin/mysqld \
478 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
479 --bootstrap \
480 --skip-grant-tables \
481 --datadir=$MYSQL_DATA_DIR \
482 --user=$MYSQL_USER \
483 --slave-load-tmpdir=$MYSQL_DATA_DIR \
484 --tmpdir=$MYSQL_DATA_DIR \
485 --log-error=$MYSQL_ERRLOG \
486 && ok=1
487 if [ "$ok" = 1 ]; then
488 ok
489 else
490 cat << END_OF_MSG
491
492WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
493The "HELP" command might not work properly.
494
495END_OF_MSG
496 fi
497 else
498 fail
499 cat << END_OF_MSG
500Installation of grant tables FAILED!
501
502The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
503
504Examine the logs in /var/log/mysql for more information. You can
505also try to start the mysqld daemon with:
506
507/usr/sbin/mysqld --skip-grant &
508
509You can use the command line tool mysql to connect to the mysql
510database and look at the grant tables:
511
512shell> mysql -u mysql mysql
513mysql> show tables
514
515Try 'mysqld --help' if you have problems with paths. Setting on
516logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
517may be helpful. The latest information about MySQL is available on the
518web at http://www.mysql.com/.
519
520Please check PLD Linux ftp site for newer versions of this package.
521
522Please consult the MySQL manual section: 'Problems running
523mysql_install_db', and the manual section that describes problems on
524your OS. Another information source is the MySQL email archive.
525
526END_OF_MSG
527 exit 1
528 fi
529}
530
531#
532# End of useful functions.
533#
534
535start() {
536 local mysqldir
537 for mysqldir in $DB_CLUSTERS; do
538 mysqlstatus "$mysqldir" start
539 if [ "$MYSQL_STATUS" = "running" ]; then
540 msg_already_running "MySQL $mysqldir"
541 else
542 mysqlstart "$mysqldir"
543 fi
544 done
545 mysqlsubsys
546}
547
548stop() {
549 local mysqldir
550 for mysqldir in $DB_CLUSTERS; do
551 mysqlstatus "$mysqldir" stop
552 if [ "$MYSQL_STATUS" = "not running" ]; then
553 msg_not_running "MySQL $mysqldir"
554 else
555 mysqlstop "$mysqldir"
556 fi
557 done
558 mysqlsubsys
559}
560
561condrestart() {
562 if [ ! -f /var/lock/subsys/mysql ]; then
563 msg_not_running "MySQL"
564 RETVAL=$1
565 return
566 fi
567
568 stop
569 start
570}
571
572RETVAL=0
573case "$action" in
574 start)
575 start
576 ;;
577 stop)
578 stop
579 ;;
580 restart)
581 stop
582 start
583 ;;
584 try-restart)
585 condrestart 0
586 ;;
587 force-reload)
588 condrestart 7
589 ;;
590 init)
591 for mysqldir in $DB_CLUSTERS; do
592 mysqlinit "$mysqldir"
593 done
594 exit $?
595 ;;
596 flush-logs)
597 for mysqldir in $DB_CLUSTERS; do
598 mysqlgetconfig "$mysqldir"
599 # just if mysqld is really running
600 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
601 /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
602 fi
603 done
604 ;;
605 status)
606 RETVAL=3
607 for mysqldir in $DB_CLUSTERS; do
608 mysqlstatus "$mysqldir"
609 if [ "$MYSQL_STATUS" = "running" ]; then
610 RETVAL=0
611 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
612 port=${MYSQL_PORT:-3306}
613 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
614 pid=$MYSQL_PID
615 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
616 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
617 nls "\tunix:%s\n" "$socket"
618 pids="$pids/$MYSQL_PID/"
619 progress "$MYSQL_STATUS"
620 else
621 show "MySQL cluster %s" "$mysqldir"
622 progress "$MYSQL_STATUS" "$CFAIL"
623 fi
624 echo
625 done
626
627 for pid in $(/sbin/pidof mysqld); do
628 if [[ $pids != */$pid/* ]]; then
629 running="$running $pid"
630 fi
631 done
632
633 if [ $# = 1 -a "$running" ]; then
634 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
635 # see if we can display their status
636 for pid in $running; do
637 datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
638 datadir=${datadir#--datadir=} # strip --datadir
639 mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
640 mysqlstatus "$mysqldir"
641 if [ "$MYSQL_STATUS" = "running" ]; then
642 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
643 port=${MYSQL_PORT:-3306}
644 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
645 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
646 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
647 nls "\tunix:%s\n" "$socket"
648 progress "$MYSQL_STATUS"
649 else
650 show "MySQL cluster %s" "$mysqldir"
651 progress "$MYSQL_STATUS" "$CFAIL"
652 fi
653 echo
654 done
655 fi
656 ;;
657 *)
658 msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
659 exit 3
660esac
661
662exit $RETVAL
This page took 0.035223 seconds and 4 git commands to generate.